c       read truncate log file to estimate what are the resolution
c       limits along a*,b*, and c*.
c       resolution limits alim,blim,clim are chosen to correspond
c       to the points where F/sigma dips below 3.5 =cutoff
	character orthobox*8,truncfile*80,phasrfile*80
        character etruncinp*80,fininfile*80,finoutfile*80
	character psfile*80,marker1*6,marker2*10,junk*80
        character marker3*17,f2mtzinp*80
        integer resno,hg,r,g,b,spgno
        real r1c1,r1c2,r1c3
        real r2c1,r2c2,r2c3
        real r3c1,r3c2,r3c3
        real deltaB,b11,b22,b33
        real loser(20),resol(20),sn1(20),sn2(20),sn3(20)
        real x1,y1,alim,blim,clim,lim1,lim2,lim3
c
        write(*,*) 'Please type truncate log file'
        read(*,'(a80)')truncfile
         print*, truncfile
        write(*,*) 'Please type phaser log file'
        read(*,'(a80)')phasrfile
         print*, phasrfile
        write(*,*) 'Type output ps file'
        read(*,'(a80)')psfile
         print*, psfile
        write(*,*) 'Type resolution limit 1'
        read(*,*)lim1
         print*, lim1
        write(*,*) 'Type resolution limit 2'
        read(*,*)lim2
         print*, lim2
        write(*,*) 'Type resolution limit 3'
        read(*,*)lim3
         print*, lim3
        write(*,*) 'Type input script for truncate program'
        read(*,'(a80)')etruncinp
         print*, etruncinp
        write(*,*) 'Type fin file for truncate program'
        read(*,'(a80)')fininfile
         print*, fininfile
        write(*,*) 'Type in fin file to be output by truncate'
        read(*,'(a80)')finoutfile
         print*, finoutfile
        write(*,*) 'Type name of f2mtz input file'
        read(*,'(a80)')f2mtzinp
         print*, f2mtzinp
        open (1,file=truncfile,status='old',form='formatted')
	open (2,file=phasrfile,status='old',form='formatted')
	open (3,file=psfile,status='new',form='formatted')
	open (4,file=etruncinp,status='new',form='formatted')
	open (5,file=f2mtzinp,status='new',form='formatted')
c Find the principle component analysis in phaser output
c It depends on the word eigenB starting in column 6 of phaser output
c Rue the day that eigenB starts in a different column               
        cutoff=3.5
   4	read (2,3,end=6)marker1
   3	format(5x,a6)
           if(marker1.eq.'eigenB')goto 7
	goto 4
   6    print*, 'You Kant always get what you want'
        go to 999
   7    print*, 'Hurray I found the principle components' 
c  get the principle component parameters
c  get the principle component parameters
 118    read (2,10)b11,r1c1,r1c2,r1c3
        read (2,10)b22,r2c1,r2c2,r2c3
        read (2,10)b33,r3c1,r3c2,r3c3
  10    format(5x,f9.3,11x,3f9.4)
        read (2,12)deltaB
  12    format(59x,f8.3)

c  write out the post script file header
        write (3,20)
  20    format ('%!PS')
        write (3,21)
  21    format ('%%BoundingBox: -100 120 600 750')
        write (3,22)
  22    format ('%%PageBoundingBox: -100 120 600 750')
        write (3,23)
  23    format ('0 setgray 1.1 1.1 scale 0 470 translate')

c make the thermometer background and scale marks
        write (3,50)
  50    format ('% make thermometer background')
        write (3,51)
  51    format ('15 setlinewidth')
        write (3,52)
  52    format ('50 40 moveto 50 160 lineto stroke')
        write (3,53)
  53    format ('50 40 20 0 360 arc fill')
        write (3,54)
  54    format ('% make thermometer scale')
        write (3,24)
        write (3,55)
  55    format ('11 scalefont setfont')
        write (3,56)
  56    format ('70 40 moveto (  0 A**2)show')
        write (3,57)
  57    format ('70 70 moveto ( 25 A**2)show')
        write (3,58)
  58    format ('70 100 moveto ( 50 A**2)show')
        write (3,59)
  59    format ('70 130 moveto ( 75 A**2)show')
        write (3,60)
  60    format ('70 160 moveto (100 A**2)show')


c  write out the priniciple component evaluation and component

        write (3,24)
  24    format ('/Helvetica findfont')
        write (3,25)
  25    format ('15 scalefont setfont')
        write (3,27)
  27    format ('125 180 moveto')
        if(deltaB.ge.50)goto 28 
        if((deltaB.ge.25).and.(deltaB.lt.50))goto 34
        if((deltaB.ge.10).and.(deltaB.lt.25))goto 31
        if(deltaB.lt.10)goto 33
  28    write (3,29)
  29    format ('(Your data has SEVERE anisotropy) show stroke')
        r=1
        g=0
        b=0
        go to 40
  34    write (3,35)
  35    format ('(Your data has STRONG anisotropy) show stroke')
        r=1
        g=1
        b=0
        go to 40
  31    write (3,32)
  32    format ('(Your data has MILD anisotropy) show stroke')
        r=0
        g=1
        b=0
        go to 40
  33    write (3,37)
  37    format('(Hurray! there is ALMOST NO anisotropy) show stroke')
        r=0
        g=0
        b=1
        go to 40
      
  40    write (3,41)
  41    format ('%fill thermometer with mercury')
c      calculate how much mercury to fill the thermometer
        hg=(120*(deltaB/100.0))+40
        write (3,42)r,g,b
  42    format (3i2,' setrgbcolor 7 setlinewidth')
        write (3,43)
  43    format ('50 40 10 0 360 arc fill')
        write (3,44)hg
  44    format ('50 40 moveto 50 ',i5,' lineto stroke')
c       level indicator
        write (3,48)hg
  48    format ('newpath 40 ',i5,' moveto -30 7 rlineto')
        write (3,49)
  49    format ('0 -14 rlineto closepath fill')

c      print out the principle components
        write (3,45)
  45    format ('0 0 0 setrgbcolor')
        write (3,46)
  46    format ('125 160 moveto')
        write (3,47)
  47    format ('(based on the spread in values of the) show')
        write (3,61)
  61    format ('125 140 moveto')
        write (3,62)deltaB
  62    format ('(three principle components= ',f6.2,' A**2) show')
        write(3,24)
        write(3,55)
c       2 lines above set smaller font i.e.10
        write(3,63)
  63    format ('145 120 moveto')
        write(3,64)
  64    format('(The principle components are the exponential) show')
        write(3,65)
  65    format ('145 105 moveto')
        write(3,66)
  66    format ('(scale factors used to correct for anisotropy.) show')
        write(3,67)
  67    format ('145  90 moveto')
        write(3,68)
  68    format ('(They may be regarded as B factors applied to) show')
        write(3,69)
  69    format ('145  75 moveto')
        write(3,70)
  70    format('(the three principle directions of the data set.) show')
        write(3,71)
  71    format ('145  60 moveto')
        write(3,72)
  72    format('(Larger |values| indicate stronger anisotropy.)show')
        write(3,24)
        write(3,25)
c       2 lines above set larger font i.e.15
        write(3,73)
  73    format ('125  40 moveto')
        write(3,74)
  74    format ('(In decreasing order the 3 components are:)show')
        write(3,75)
  75    format ('125  20 moveto')
        write(3,76)b11,b22,b33
  76    format ('(',3f8.2,' A**2)show stroke')

c    Parse the F/sigma vs. resolution plot from truncate
  84    read (1,83,end=86)marker2
  83    format(10x,a10)
           if(marker2.eq.'Anisotropy')goto 87
        goto 84
  86    print*, 'You cant Hegel your way out of this one.'
        go to 999
  87    print*, 'Hurray I found the F/sigma vs. resolution plot'
c  get the F/sigmas and resolutions
        write(3,97)
  97    format('5 setlinewidth')
        do 88 i=1,5
         read (1,90)junk
  90     format(a80)
  88    continue
        do 89 i=1,20
         read (1,92)loser(i),sn1(i),sn2(i),sn3(i)
  92     format (f8.5,36x,3f9.2)
         resol(i)=SQRT(1/loser(i))
c PLOT F/sigma for a* direction
c Quick check if space group is hexagonal, then
c F/sigma along a* will be zero.  You need to make it equal to b*.
         sn1sum=0.0
         do 322 nnn=1,20
          sn1sum=sn1sum+(sn1(nnn))
322      continue
         if(sn1sum.eq.0)then
          do 323 nnn=1,20
          sn1(nnn)=sn2(nnn)
323      continue
         endif

         x1=(i*15)+100
         y1=((sn1(i)/50)*200) -200
         r=1
         g=0
         b=0
         if(i.gt.1)then
          x0=((i-1)*15)+100
          y0=((sn1(i-1)/50)*200) -200
          write(3,93)r,g,b
  93      format(3i2,' setrgbcolor')
          write(3,91)x0,y0,x1,y1
  91      format(2f8.2,' moveto',2f8.2,' lineto stroke')
         endif
c PLOT F/sigma for b* direction
c Quick check if space group is tetragonal, then
c F/sigma along b* will be zero.  You need to make it equal to a*.
         sn2sum=0.0
         do 324 nnn=1,20
          sn2sum=sn2sum+(sn2(nnn))
324      continue
         if(sn2sum.eq.0)then
          do 325 nnn=1,20
          sn2(nnn)=sn1(nnn)
325      continue
         endif

         y1=((sn2(i)/50)*200) -200
         r=0
         g=1
         b=0
         if(i.gt.1)then
          y0=((sn2(i-1)/50)*200) -200
          write(3,93)r,g,b
          write(3,91)x0,y0,x1,y1
         endif
c PLOT F/sigma for c* direction
c Quick check if space group is cubic, then
c F/sigma along a* and c* will be zero.  You need to make it equal to b*.
c Of course, by this point, you will already have fixed a*.
         sn3sum=0.0
         do 326 nnn=1,20
          sn3sum=sn3sum+(sn3(nnn))
326      continue
         if(sn3sum.eq.0)then
          do 327 nnn=1,20
          sn3(nnn)=sn2(nnn)
327      continue
         endif

         y1=((sn3(i)/50)*200) -200
         r=0
         g=0
         b=1
         if(i.gt.1)then
          y0=((sn3(i-1)/50)*200) -200
          write(3,93)r,g,b
          write(3,91)x0,y0,x1,y1
         endif
  89    continue
c Draw F/sigma=3.0 cutoff line
        write (3,95) 
  95    format ('2 setlinewidth')
        ycut=((cutoff/50)*200) -200
        write(3,45)
        xmin=100
        xmax=400
        write(3,96)xmin-10,ycut,xmax,ycut
  96    format(2f8.2,' moveto',2f8.2,' lineto stroke')
c Draw X and Y axes
        write(3,97)
        ymin=-200
        ymax=0
        write(3,96)xmin,ymin,xmax,ymin
        write(3,96)xmin,ymin,xmin,ymax
c Label plot
        write(3,100)
 100    format('20 -100 moveto (F/sigma)show stroke')
        write(3,101)
 101    format('210 -240 moveto (resolution)show stroke')
        write(3,102)ycut
 102    format('60 ',f8.3,' moveto (3.0)show stroke')
c Put tick labels for resolution
       do 103, i=2,20,2
        x1=(i*15)+100
c       the tick
        write(3,95)
        write(3,96)x1,ymin+5,x1,ymin-5
c       the label
        write(3,104)x1-20,ymin-20,resol(i)
 104    format(2f8.2,' moveto (',f4.1,') show stroke')
 103   continue
c Check what are the resolution limits for the ellipse axes
c If user has not input desired limits, then determine them from
c the plot of F/sigma versus resolution. When F/sigma dips below cutoff
c then that is the limit.
c Use i=4,20 instead of i=1,20 to avoid problems of missing low res shells.
       do 105, i=4,20
        alim=resol(i)
        if(sn1(i).le.cutoff)then
        go to 106
        endif
 105    continue
 106   do 107, i=4,20
        blim=resol(i)
        if(sn2(i).le.cutoff)then
        go to 108
        endif
 107    continue
 108   do 109, i=4,20
        clim=resol(i)
        if(sn3(i).le.cutoff)then
        go to 110
        endif
 109   continue
c If user has input desired limits, then use these
 110   if((lim1.ne.0).or.(lim2.ne.0).or.(lim3.ne.0))then
        if(lim1.ne.0) alim=lim1
        if(lim2.ne.0) blim=lim2
        if(lim3.ne.0) clim=lim3
        write(3,212)xmin-50,ymin-80
 212    format(2f9.1,' moveto (User input resolution) show')
        goto 213
       endif

       write(3,112)xmin-50,ymin-80
 112   format(2f9.1,' moveto (The recommended resolution) show')

 213   write(3,113)xmin+150,ymin-80
 113   format(2f9.1,' moveto (limits along/near a*,b*,c* are) show')

       r=1
       g=0
       b=0
       write(3,93)r,g,b
       write(3,124)xmin,ymin-100,alim
 124   format(2f9.1,' moveto (',f9.1,' Ang) show')
       write(3,127)xmax-100,ymax-40
 127   format(2f9.1,' moveto (a* direction) show')
       r=0
       g=1
       b=0
       write(3,93)r,g,b
       write(3,125)xmin+70,ymin-100,blim
 125   format(2f9.1,' moveto (',f9.1,' Ang) show')
       write(3,128)xmax-100,ymax-55
 128   format(2f9.1,' moveto (b* direction) show')
       r=0
       g=0
       b=1
       write(3,93)r,g,b
       write(3,125)xmin+140,ymin-100,clim
 126   format(2f9.1,' moveto (',f9.1,' Ang) show')
       write(3,129)xmax-100,ymax-70
 129   format(2f9.1,' moveto (c* direction) show')

       write (3,45)
       write (3,24)
       write (3,55)
       write(3,115)xmin+40,ymin-120
 115   format(2f9.1,' moveto')
       write(3,116)
 116   format('(These are the resolutions at which F/sigma) show')
       write(3,117)xmin+40,ymin-135
 117   format(2f9.1,' moveto')
       write(3,119)
 119   format('(drops below an arbitrary cutoff of 3.0) show')

c  NOW is the time to prepare the command file for truncategellipse
c  first I have to find the unit cell parameters somewhere
 	close (unit=2)
        open (2,file=phasrfile,status='old',form='formatted')
 134    read (2,133,end=136)marker3
 133    format(3x,a17)
           if(marker3.eq.'Space-Group Name ')goto 137
        goto 134
 136    print*, 'I cant find my Nietzsche in life'
        go to 999
 137    print*, 'Hurray I found the unit cell'
        read (2,138)spgno
 138    format (22x,i4)
        read (2,139)au,bu,cu,ad,bd,cd
 139    format (13x,6f8.2)
c  Write out the command file for truncategellipse
        write (4,140)fininfile
        write (4,140)finoutfile
 140    format (a80)
        write (4,141)au,bu,cu,ad,bd,cd
 141    format (6f8.2)
        write (4,143)r1c1,r1c2,r1c3,r2c1,r2c2,r2c3,r3c1,r3c2,r3c3
 143    format (9f12.4)
        write (4,144)alim,blim,clim
 144    format (3f12.4)
c  Write out the command file for f2mtz
        write (5,145)
 145    format ('title convert truncated fin file to mtz format')
        write (5,146)spgno
 146    format ('symmetry ',i3)
        write (5,147)au,bu,cu,ad,bd,cd
 147    format ('cell ',6f8.2)
        write (5,148)
 148    format ('labout H K L FP SIGFP')
        write (5,149)
 149    format ('ctypout H H H F Q')
        write (5,150)
 150    format ('end')

 941    write (3,942)
 942    format ('showpage')

c       lalalalalalallalalalalalallalalalalalalalalalalalalalal
  11    print *, 'bye'
 999	stop
	end
