c Read XSCALE stats before and after ellipsoidal truncation to compare Rsym
c Mike Sawaya June 22, 2010
        character line*90,xscalefile1*90
        character xscalefile2*90
        character rsymstatsfile*90
        character reslim(2,21)*6
        real nobs(2,21),nuni(2,21),npos(2,21)
        real comp(2,21),robs(2,21),iosi(2,21),redu(2,21)
        integer inobs(2,21)
c
	write(*,*) 'Please name starting XSCALE.LP file'
	read(*,'(a90)')xscalefile1
	print*, 'Please name final XSCALE.LP file'
	read (*,'(a90)')xscalefile2
	print*, 'Please name output statistics file'
	read (*,'(a90)')rsymstatsfile
	open (1,file=xscalefile1,status='old',form='formatted')
	open (2,file=xscalefile2,status='old',form='formatted')
	open (3,file=rsymstatsfile,status='new',form='formatted')
   3    format(a90)

        do 14 j=1,2
c       skip header
  10    read (j,3,end=6)line
        if(line(46:51).eq.'= -3.0')go to 5
        go to 10
   5    read (j,3)line
        read (j,3)line
        read (j,3)line

c       Read statistics
        do 13 i=1,21
   4	read (j,3)line
        reslim(j,i)=line(4:9)
        read (line(16:21),*)nobs(j,i)
        read (line(24:29),*)nuni(j,i)
        read (line(33:39),*)npos(j,i)
        read (line(46:50),*)comp(j,i)
        read (line(57:61),*)robs(j,i)
        read (line(84:89),*)iosi(j,i)
        redu(j,i)=nobs(j,i)/npos(j,i)
        inobs(j,i)=nobs(j,i)
 13     continue
 14     continue


c      write statistics
        write(3,*)'<pre>'
        write(3,*)'resolution   observed     redundancy    completenes
     1      rmerge         i/sigma '
        write(3,*)'           before/after  before/after   before/after
     1   before/after   before/after'
        do 15,i=1,21
        write(3,12)reslim(1,i),inobs(1,i),inobs(2,i),redu(1,i),
     1 redu(2,i),comp(1,i),comp(2,i),robs(1,i),robs(2,i),iosi(1,i),
     1 iosi(2,i)
  12    format(a8,3x,i6,i6,3x,f5.1,f5.1,1x,f7.1,'%',f7.1,'%',1x,f7.1,
     1 '%',f6.1,'%',1x,f7.1,f6.1)
  15    continue
        write(3,*)'</pre>'
   6    print*, 'all done'
	stop
	end

